//
//  NEXDouble.h
//  NumberEightCompiled
//
//  Created by Matthew Paletta on 2021-05-20.
//  Copyright © 2021 NumberEight Technologies Ltd. All rights reserved.
//
#pragma once

#import "NEDouble.h"
#import "NEXSensorItem.h"

NS_ASSUME_NONNULL_BEGIN

/**
 * Encapsulates a double-precision floating point number.
 */
@interface NEXDouble : NEXSensorItem

/**
 * Default constructor.
 */
- (instancetype)init;

/**
 * Default constructor.
 */
+ (instancetype)new;

/**
 * Conversion copy constructor.
 * @param value NEDouble to copy from.
 */
- (instancetype)initWithDouble:(NEDouble)value;

/**
 * Conversion copy constructor.
 * @param value NEDouble to copy from.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithDouble:(NEDouble)value confidence:(double)confidence;

/**
 * @param rawValue The primitive floating point value.
 */
- (instancetype)initWithRawValue:(double)rawValue;

/**
 * @param rawValue The primitive floating point value.
 * @param confidence An optional confidence level from 0.0 (min) to 1.0 (max).
 */
- (instancetype)initWithRawValue:(double)rawValue confidence:(double)confidence;

/**
 * Parse a string in serialized form.
 * @param string The serialized string, as generated by serialize()
 *
 * @return `nil` if unserialization failed.
 */
+ (instancetype _Nullable)unserializeWithString:(NSString*)string;

@property(nonatomic, readonly) NEDouble value DEPRECATED_ATTRIBUTE;

/**
 * Underlying value.
 */
@property(nonatomic, readwrite) double rawValue;

/**
 * @return A hash value representing the state of the Type.
 *          Can be used for checking equality.
 */
@property(nonatomic, readonly) NSUInteger hash;

/**
 * @return The name of the concrete value class extending NEXSensorItem.
 */
@property(nonatomic, readonly) NSString* type;

/**
 * @return A human-readable format of the held data.
 */
@property(nonatomic, readonly) NSString* description;

/**
 * @return A machine-readable format of the held data.  Returns `nil` if @p type is invalid, or if
 * serialization failed.
 */
- (NSString* _Nullable)serialize;

/**
 * Strict equality comparison.
 *
 * @see NEDouble_isEqual
 *
 * @param object Value to compare with.
 */
- (BOOL)isEqual:(id _Nullable)object;

- (BOOL)approximatelyEqualToRawValue:(double)rawValue;

- (BOOL)approximatelyEqualToOther:(NEXDouble*)other;

/**
 * Convert the Objective-C class to a C-compatible struct.
 */
- (NEDouble)c_val;

@end

NS_ASSUME_NONNULL_END
